import swarm.Globals;
import swarm.defobj.*;
import swarm.objectbase.SwarmObjectImpl;;

public class SimpleBug extends SwarmObjectImpl
{
	FoodSpace myFoodSpace;
	int worldXSize;
	int worldYSize;
	int xPos;
	int yPos;
	int bugNumber;
	
	
	//Constructor to create a SimpleBug object in Zone aZone and place it
	
	public SimpleBug (Zone aZone, FoodSpace fSpace, int X, int Y, int bNum)
	{
		//Call Constructor
		super (aZone);
		
		//Record the bug's foodspace, initial position and id number
		
		myFoodSpace = fSpace;
		worldXSize = myFoodSpace.getSizeX();
		worldYSize = myFoodSpace.getSizeY();
		xPos = X;
		yPos = Y;
		bugNumber = bNum;
		
		//The bug'S world
		//worldXSize = wXSize;
		//worldYSize = wYSize;
		//xPos = X;
		//yPos = Y;
		//bugNumber= bNum;
		
		//Console Announcement
		System.out.println("Simple Bug Nr. " + bugNumber + "obeys orders at " + xPos + ", " + yPos);
		System.out.println(this);
			}
			//Random walk
			
			public void randomWalk()
			{
				xPos += Globals.env.uniformIntRand.getIntegerWithMin$withMax(-1, 1);
				yPos += Globals.env.uniformIntRand.getIntegerWithMin$withMax(-1, 1);
				xPos = (xPos + worldXSize) % worldXSize;
				yPos = (yPos + worldYSize) % worldYSize;
			}
			
			//If there is food: Eat it!
			if (myFoodspace.getValueAtX$Y(xPos, yPos) ==  1)
			{
				myFoodSpace.putValue$atX$Y(0, xPos, yPos);
				System.out.println ("Bug " + bugNumber + " has found food at " + xPos+ ", " + yPos);
			}
			}
			
		//Method: Report bug's location	
			public void reportPosition()
		{
			System.out.println("Bug " + bugNumber + "now obeys orders at " + xPos + "," + yPos);		
		}
				
	
